
@#define countries = [ "H", "U", "E" ]
//%H=1, U=2, E=3
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
var
@#for co in countries
q_c_@{co}	C_@{co}		C_d_@{co}	C_no_@{co}	K_@{co}		I_@{co}		I_d_@{co}		Q_k_@{co}	r_k_@{co}	O_c_@{co}   //gama_@{co}

L_@{co}		L_d_@{co}	w_@{co}		w_f_@{co}	wstr_@{co}	omega_l_@{co}	omega_@{co}	S1_w_@{co}	S2_w_@{co}

P_r_@{co}	P_sc_@{co}	P_si_@{co}	P_so_@{co}	P_sno_@{co}		P_b_@{co}	P_sm_@{co}	S1_p_@{co}	S2_p_@{co}

Lmbd_@{co}	r_s_@{co}	G_d_@{co}	O_@{co}		//%D_@{co}		

Y_@{co}		Y_d_@{co}	VA_@{co}	O_y_@{co}	lmbd_sv_@{co}	mc_@{co}

X_@{co}		NTs_@{co}	M_c_@{co}	M_i_@{co}	M_@{co}	
	
pi_d_@{co}	pi_hd_@{co} pi_l_@{co}	pibar_core_@{co}    pi_core_@{co}     ygap_@{co}

Z_@{co}		Z_c_@{co}	Z_o_@{co}	Z_m_@{co}  	 Z_i_@{co}	Z_g_@{co}
psi_w_@{co}	psi_p_@{co}	theta_p_@{co}	theta_w_@{co}

@#endfor
P_sm_HE		P_sm_HU		P_sm_UH		P_sm_UE		P_sm_EU		P_sm_EH
M_c_HE		M_c_HU		M_c_UH		M_c_UE		M_c_EU		M_c_EH
M_i_HE		M_i_HU		M_i_UH		M_i_UE		M_i_EU		M_i_EH
M_HE		M_HU		M_UH		M_UE		M_EU		M_EH
B_s_HE		B_s_HU		B_s_UH		B_s_UE		B_s_EU		B_s_EH	
rer_HE		rer_HU		rer_UH		rer_UE		rer_EU		rer_EH	

phi_b_HU    phi_b_HE    phi_b_EH    phi_b_EU    phi_b_UE    phi_b_UH

//%Oil Exporters Specific Variables
Y_o     O_x     F_u		F		u_op		O		NF		u_nf		S_F
S1_o	S2_o 	omega_o			pi_o		Pstr_o    mc_o
r_f		K_o		K_y
Z_op	Z_nf	psi_o   theta_o
;
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%  VAREXO  %%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

varexo
@#for co in countries
eps_z_@{co}	eps_zo_@{co}	eps_zg_@{co}	eps_zi_@{co}	eps_p_@{co}	eps_w_@{co}	eps_pi_@{co}
@#endfor
eps_o	eps_zop		eps_znf;

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%  Deep Params  %%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
parameters
@#for co in countries
dlt_oy_@{co}
dlt_l_@{co}		
dlt_oc_@{co}	
dlt_mc_@{co}	
dlt_i_@{co}

rho_w_@{co}	tau_w_@{co}	gama_w_@{co}
rho_p_@{co}	tau_p_@{co}	gama_p_@{co}

beta_@{co}     g_@{co}
gamma_r_@{co} gamma_pi_@{co}    gamma_y_@{co}

@#endfor
r_o	r_v	r_c	r_m
sig   dlt	kappa	chi	chi0	psi_i

mu_z	mu_o	mu_zo
zetaE	zetaU
phi_b
rho_o   gama_o

dlt_HE  dlt_EU  dlt_UH
dlt_EH  dlt_UE  dlt_HU

rho_z 	sig_z
rho_zc	sig_zc
rho_zm	sig_zm
rho_zo	sig_zo
rho_zg	sig_zg
rho_zi	sig_zi
rho_zp	sig_p
rho_zw	sig_w
rho_zpo	sig_po
rho_zop sig_zop
rho_znf sig_znf
rho_pi  sig_pi
;

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//	%%%%%%%%% Deep Param Values    %%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@#for co in countries
dlt_oy_@{co}    =   0.026;	
dlt_l_@{co}     =   0.3;	
dlt_mc_@{co}	=   0.068;  
dlt_i_@{co}     =   0.09;


rho_w_@{co} =0.81;	tau_w_@{co}=0;	gama_w_@{co}=0.001;
rho_p_@{co} =0.89;	tau_p_@{co}=0;	gama_p_@{co}=0.001;

//Monetary Ploicy
gama_pi_@{co}=	0.197;	
gama_r_@{co}=	0.653;	
gama_y_@{co}=	0.0000;
beta_@{co} =   .99;
g_@{co}  = .2;

gamma_r_@{co} = .6; gamma_pi_@{co}=.2; gamma_y_@{co}=.001;

@#endfor
r_o =   -1.6;	r_v = -1.6; r_c =  -1.6;  	r_m	=   -1.6; 
sig=  .99;      dlt=.025;	kappa=  0.6;	chi=0;	chi0=   5;	psi_i=   3.5;
mu_z = 1;		mu_o=1;     mu_zo=1;
zetaE = 1;	zetaU=1;
dlt_HE = .5;
dlt_HU = .5;
dlt_UE = .5;
dlt_EU = .5;
dlt_UH = .5;
dlt_EH = .5;

phi_b =  0.001;
rho_o= .8;  gama_o = .001;

rho_z =.02; 	sig_z = .02;
rho_zc= .02;	sig_zc= .02;
rho_zm= .02;	sig_zm= .02;
rho_zo= .02;	sig_zo= .02;
rho_zg= .02;	sig_zg= .02;
rho_zi= .02;	sig_zi= .02;
rho_zp= .02;	sig_p = .02;
rho_zw= .02;    sig_w = .02;
rho_zpo=.02;	sig_po= .02;
rho_zop=.02;    sig_zop=.02;
rho_znf=.02;    sig_znf=.02;
rho_pi=.02;     sig_pi =.02;

//%Home country doesn't consume oil in household level. 
dlt_oc_U= 0.022;	dlt_oc_E= 0.022;	 dlt_oc_H= 0.05;


//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%     MODEL;      %%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
model;
@#for co in countries
//%(1) FOC for Ct
Z_c_@{co}*(Z_c_@{co}*C_@{co}  - kappa*C_@{co}(-1))^(-sig)	 =	 q_c_@{co}*P_sc_@{co};

//%(2) Capital accumulation
K_@{co}	=	(1-dlt)*K_@{co}(-1)	+	Z_i_@{co}*I_@{co}*(	1	-	(psi_i/2)*(	I_@{co}/I_@{co}(-1) - mu_z	)^2	);

//%(3) Labour 
chi0*(1-L_@{co})^(-chi) 	=	 q_c_@{co}*w_f_@{co};

//%(4) Investment
Z_i_@{co}*Q_k_@{co}*(1 - 0.5*psi_i*(	I_@{co}/I_@{co}(-1) - mu_z	)*(3*I_@{co}/I_@{co}(-1) - mu_z)	) + beta_@{co}*Z_i_@{co}(+1)*Q_k_@{co}(+1)*psi_i*((I_@{co}(+1)/I_@{co})^2)*(I_@{co}(+1)/I_@{co}	-	mu_z	)  - 	q_c_@{co}*P_si_@{co}		 = 0;

//%(5) Capital
Q_k_@{co} = beta_@{co}*q_c_@{co}(+1)*r_k_@{co}(+1)	 + 	beta_@{co}*(1-dlt)*Q_k_@{co}(+1);

//%(6) Nominal Interest rate (domestic bond)
r_s_@{co}^(-1)	=	beta_@{co}*(q_c_@{co}(+1)/q_c_@{co})*(1/pi_d_@{co});

//%(7) discount factor (according to bodenstein)
Lmbd_@{co}	=	beta_@{co}*(q_c_@{co}(+1)/q_c_@{co});

//%%%%%%%%%%%%%%%     Monetary Policy;      %%%%%%%%%%%%%
//(??) Taylor rule
r_s_@{co}	=	gamma_r_@{co}*r_s_@{co}(-1)	+	(1-gamma_r_@{co})*(	pi_core_@{co}	+	gamma_pi_@{co}*(pi_core_@{co}   -	pibar_core_@{co})	+	gamma_y_@{co}*ygap_@{co}	);

//(??) Core inflation
pi_core_@{co}	=	(P_sno_@{co}/P_sno_@{co}(-1))*(1/pi_d_@{co});
//(??) headline inflation
pi_hd_@{co}	=	P_sc_@{co}/P_sc_@{co}(-1)*(1/pi_d_@{co});

ygap_@{co}=(1-beta_@{co})/(beta_@{co}*gamma_y_@{co});

//%%%%%%%%%%%%%%%     Labour      %%%%%%%%%%%%%
//%(8) labour demand
L_@{co}	=	(wstr_@{co}/w_@{co})^(-psi_w_@{co})*L_d_@{co};

//%(9) Wage Inflation
omega_@{co}	= (w_@{co}/w_@{co}(-1))*pi_d_@{co};

//%(10) Wage inflation adjustment
omega_l_@{co}	=	(omega_@{co})^gama_w_@{co}*(STEADY_STATE(pi_d_@{co}))^(1-gama_w_@{co});

//%(11)Wage Setting
S1_w_@{co}	=	wstr_@{co}*S2_w_@{co};
//%(12) 
S1_w_@{co}	=	psi_w_@{co}*L_@{co}*w_f_@{co}	+	omega_@{co}*Lmbd_@{co}*rho_w_@{co}*S1_w_@{co}(+1);
//%(13)
S2_w_@{co}	=	(psi_w_@{co}-1)*L_@{co}*(1+tau_w_@{co})	+	Lmbd_@{co}*omega_l_@{co}*rho_w_@{co}*S2_w_@{co}(+1);

//%(14) wage evolution:
w_@{co}^(1-psi_w_@{co})	=	rho_w_@{co}*(	w_@{co}(-1)*omega_l_@{co}(-1)/pi_d_@{co}	)^(1-psi_w_@{co})	+	(1	-	rho_w_@{co})*wstr_@{co}^(1-psi_w_@{co});

//%(15) Production, aggregate intermediate goods,
Y_@{co}	=	(	(1-dlt_oy_@{co})^(1-r_o)*VA_@{co}^r_o	+	dlt_oy_@{co}^(1-r_o)*(mu_zo*Z_o_@{co}*O_y_@{co})^r_o	)^(1/r_o);

//%(18) Labour 
w_@{co}	=	mc_@{co}*(		(1-dlt_oy_@{co})*Y_@{co}/VA_@{co}		)^(1-r_o)*(		dlt_l_@{co}*VA_@{co}/(	mu_z*Z_@{co}*L_d_@{co}	)	)^(1-r_v)*(mu_z*Z_@{co});	

//%(19) Oil
P_so_@{co}	=	mc_@{co}*(	dlt_oy_@{co}*Y_@{co}/(mu_zo*Z_o_@{co}*O_y_@{co})	)^(1-r_o)*(mu_z*Z_o_@{co});

//%(20) MC_VA
lmbd_sv_@{co}	=	(	(1-dlt_l_@{co})	*r_k_@{co}^(r_v/(r_v-1))	+	dlt_l_@{co}*(w_@{co}/(mu_z*Z_@{co}))^(r_v/(r_v-1))		)^((r_v-1)/r_v);

//% (21) MC
mc_@{co}	=	(	(1-dlt_oy_@{co})	*lmbd_sv_@{co}^(r_o/(r_o-1))		+	dlt_oy_@{co}*(P_so_@{co}/(mu_zo*Z_o_@{co}))^(r_o/(r_o-1))		)^((r_o-1)/r_o);

//%(22) Price Setting
S1_p_@{co}	=	P_r_@{co}*S2_p_@{co};
//%(23) 
S1_p_@{co}	=	Y_@{co}*psi_p_@{co}*mc_@{co}	+	pi_d_@{co}*Lmbd_@{co}*rho_p_@{co}*S1_p_@{co}(+1);
//%(24) 
S2_p_@{co}	=	Y_@{co}*(psi_p_@{co} - 1)*(1+tau_p_@{co})	+	rho_p_@{co}*Lmbd_@{co}*pi_l_@{co}*S2_p_@{co}(+1);

//%(25) Price Inflation Adjustment
pi_l_@{co}	=	pi_d_@{co}^gama_p_@{co}*(STEADY_STATE(pi_d_@{co}))^(1-gama_p_@{co});

//%(26) Price Evolution 
1	=	rho_p_@{co}*(	pi_l_@{co}(-1)/pi_d_@{co}		)^(1-psi_p_@{co})	+	(1	-	rho_p_@{co})*(		P_r_@{co}	)^(1-psi_p_@{co});	

//%(27) Output demand
Y_@{co}	=	(	P_r_@{co}	)^(-psi_p_@{co})*	Y_d_@{co};

//%(28) Consumption Bundle
C_@{co} = (	(1-dlt_oc_@{co})^(1-r_o)*C_no_@{co}^r_o	+	dlt_oc_@{co}^(1-r_o)*(mu_zo*Z_o_@{co}*O_c_@{co})^r_o    )^(1/r_o);
P_sc_@{co} = (   (1-dlt_oc_@{co})*P_sno_@{co}^(r_o / (r_o-1))   +   dlt_oc_@{co}*P_so_@{co}^(r_o / (r_o-1))    )^((r_o-1)/ r_o);

//%(29) Core Consumption Bundle
C_no_@{co} = (	(1-dlt_mc_@{co})^(1-r_c)*C_d_@{co}^r_c	+	dlt_mc_@{co}^(1-r_c)*(Z_m_@{co}*M_c_@{co})^r_c		)^(1/r_c);
P_sno_@{co} = (   (1-dlt_mc_@{co})   +   dlt_mc_@{co}*P_sm_@{co}^(r_c/ (r_c-1))    )^((r_c-1) / r_c);

//%(39) 
1		=	P_sc_@{co} 	*(	(1-dlt_oc_@{co})*C_@{co}/C_no_@{co}	)^(1-r_o)*((1-dlt_mc_@{co})*C_no_@{co}/C_d_@{co}	)^(1-r_c);

//%(40)
P_so_@{co}	=	P_sc_@{co}	*(	dlt_oc_@{co}*C_@{co}/(mu_zo*Z_o_@{co}*O_c_@{co})	)^(1-r_o)*mu_zo*Z_o_@{co};

//%(44) Investment Bundle
I_@{co}	=	(	(1-dlt_i_@{co})^(1-r_c)*I_d_@{co}^r_c	+	dlt_i_@{co}^(1-r_c)*(	Z_i_@{co}*M_i_@{co}	)^r_c	)^(1/r_c);
P_si_@{co} = (   (1-dlt_i_@{co})   +   dlt_i_@{co}*P_sm_@{co}^(r_c/ (r_c-1))    )^((r_c-1) / r_c);

//%(48) Demand Domestic Investment Goods
1 	=	P_si_@{co}*((1-dlt_i_@{co})*I_@{co}/I_d_@{co})^(1-r_c);

//%(73) Market Clearing Condition
Y_d_@{co}	=	C_d_@{co}	+	I_d_@{co}		+	X_@{co}	+	G_d_@{co};

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%      Shocks       %%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

log(Z_@{co}	)	=	rho_z*log(Z_@{co}(-1))		+	sig_z*eps_z_@{co};
log(Z_c_@{co})	=	rho_zc*log(Z_c_@{co}(-1))	+	sig_zc*eps_z_@{co};
log(Z_m_@{co})	=	rho_zm*log(Z_m_@{co}(-1))	+	sig_zm*eps_z_@{co};
log(Z_o_@{co})	=	rho_zo*log(Z_o_@{co}(-1))	+	sig_zo*eps_zo_@{co};
log(Z_g_@{co})	=	rho_zg*log(Z_g_@{co}(-1))	+	sig_zg*eps_zg_@{co};
log(Z_i_@{co})	=	rho_zi*log(Z_i_@{co}(-1))		+	sig_zi*eps_zi_@{co};

log(theta_p_@{co})	=	rho_zp*log(theta_p_@{co}(-1))	+	sig_p*eps_p_@{co};
log(theta_w_@{co})	=	rho_zw*log(theta_w_@{co}(-1))	+	sig_w*eps_w_@{co};
psi_p_@{co}	=	(1+theta_p_@{co})/theta_p_@{co};
psi_w_@{co}	=	(1+theta_w_@{co})/theta_w_@{co};

log(pibar_core_@{co}) = rho_pi*log(pibar_core_@{co}(-1))  + sig_pi*eps_pi_@{co};

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@#endfor
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//Capital Demand in Production
//%(16) Value Added
VA_U		=	(	(1-dlt_l_U)^(1-r_v)*K_U(-1)^r_v		+	dlt_l_U^(1-r_v)*(mu_z*Z_U*L_U)^r_v	)^(1/r_v);
//%(17) Capital 
r_k_U	=	mc_U*(	(1-dlt_oy_U)*Y_U/VA_U	)^(1-r_o)*(	(1-dlt_l_U)*VA_U/K_U(-1)	)^(1-r_v);

//%(16) Value Added
VA_E		=	(	(1-dlt_l_E)^(1-r_v)*K_E(-1)^r_v		+	dlt_l_E^(1-r_v)*(mu_z*Z_E*L_E)^r_v	)^(1/r_v);
//%(17) Capital 
r_k_E	=	mc_E*(	(1-dlt_oy_E)*Y_E/VA_E	)^(1-r_o)*(	(1-dlt_l_E)*VA_E/K_E(-1)	)^(1-r_v);

//%(16) Value Added
VA_H		=	(	(1-dlt_l_H)^(1-r_v)*K_y(-1)^r_v		+	dlt_l_H^(1-r_v)*(mu_z*Z_H*L_H)^r_v	)^(1/r_v);
//%(17) Capital 
r_k_H	=	mc_H*(	(1-dlt_oy_H)*Y_H/VA_H	)^(1-r_o)*(	(1-dlt_l_H)*VA_H/K_y(-1)	)^(1-r_v);

K_H =  K_y + K_o;
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%     Bilateral Equations;      %%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//%(30) Imported Core Goods for Consumption  Bundle
M_c_H = (	dlt_HU^(1-r_m)*M_c_HU^r_m	+	(1-dlt_HU)^(1-r_m)*M_c_HE^r_m	)^(1/r_m);
//%(31)
M_c_U = (	dlt_UH^(1-r_m)*M_c_UH^r_m	+	(1-dlt_UH)^(1-r_m)*M_c_UE^r_m	)^(1/r_m);
//%(32)
M_c_E = (	dlt_EH^(1-r_m)*M_c_EH^r_m	+	(1-dlt_EH)^(1-r_m)*M_c_EU^r_m	)^(1/r_m);

//%(33) Import prices
P_sm_HE	=	P_sc_H*(	((1-dlt_oc_H)*C_H)/C_no_H	)^(1-r_o)*	(	dlt_mc_H*C_no_H/(Z_m_H*M_c_H)	)^(1-r_c)*(	(1-dlt_HU)*M_c_H/M_c_HE	)^(1-r_m)*Z_m_H;
//%(34)
P_sm_HU	=	P_sc_H*(	((1-dlt_oc_H)*C_H)/C_no_H	)^(1-r_o)*	(	dlt_mc_H*C_no_H/(Z_m_H*M_c_H)	)^(1-r_c)*(	dlt_HU*M_c_H/M_c_HU	)^(1-r_m)*Z_m_H;
//%(35)
P_sm_EU	=	P_sc_E*(	((1-dlt_oc_E)*C_E)/C_no_E	)^(1-r_o)*	(	dlt_mc_E*C_no_E/(Z_m_E*M_c_E)	)^(1-r_c)*(	(1-dlt_EH)*M_c_E/M_c_EU	)^(1-r_m)*Z_m_E;
//%(36)
P_sm_EH	=	P_sc_E*(	((1-dlt_oc_E)*C_E)/C_no_E	)^(1-r_o)*	(	dlt_mc_E*C_no_E/(Z_m_E*M_c_E)	)^(1-r_c)*(	dlt_EH*M_c_E/M_c_EH	)^(1-r_m)*Z_m_E;
//%(37)
P_sm_UH	=	P_sc_U*(	((1-dlt_oc_U)*C_U)/C_no_U	)^(1-r_o)*	(	dlt_mc_U*C_no_U/(Z_m_U*M_c_U)	)^(1-r_c)*(	dlt_UH*M_c_U/M_c_UH	)^(1-r_m)*Z_m_U;
//%(38)
P_sm_UE	=	P_sc_U*(	((1-dlt_oc_U)*C_U)/C_no_U	)^(1-r_o)*	(	dlt_mc_U*C_no_U/(Z_m_U*M_c_U)	)^(1-r_c)*(	(1-dlt_UH)*M_c_U/M_c_UE	)^(1-r_m)*Z_m_U;

//%(41) Import Price
P_sm_H	=	((dlt_HU)*P_sm_HU^(r_m/(r_m-1))		+	(1-dlt_HU)*P_sm_HE^(r_m/(r_m-1)))^((r_m-1)/r_m);
//%(42) Import Price
P_sm_U	=	((dlt_UH)*P_sm_UH^(r_m/(r_m-1))		+	(1-dlt_UH)*P_sm_UE^(r_m/(r_m-1)))^((r_m-1)/r_m);
//%(43) Import Price
P_sm_E	=	((dlt_EH)*P_sm_EH^(r_m/(r_m-1))		+	(1-dlt_EH)*P_sm_EU^(r_m/(r_m-1)))^((r_m-1)/r_m);

//%(45) Imported Core Goods for Investment Bundle
M_i_H = (	dlt_HU^(1-r_m)*M_i_HU^r_m	+	(1-dlt_HU)^(1-r_m)*M_i_HE^r_m	)^(1/r_m);
//%(46)
M_i_U = (	dlt_UH^(1-r_m)*M_i_UH^r_m	+	(1-dlt_UH)^(1-r_m)*M_i_UE^r_m	)^(1/r_m);
//%(47)
M_i_E = (	dlt_EH^(1-r_m)*M_i_EH^r_m	+	(1-dlt_EH)^(1-r_m)*M_i_EU^r_m	)^(1/r_m);
//%(49) Import prices (investment)
P_sm_HU	=	P_si_H*	(	dlt_i_H*I_H/(Z_m_H*M_i_H)	)^(1-r_c)*(	dlt_HU*M_i_H/M_i_HU	)^(1-r_m)*Z_m_H;
//%(50)
P_sm_HE	=	P_si_H*	(	dlt_i_H*I_H/(Z_m_H*M_i_H)	)^(1-r_c)*(	(1-dlt_HU)*M_i_H/M_i_HE	)^(1-r_m)*Z_m_H;
//%(51)
P_sm_UE	=	P_si_U*	(	dlt_i_U*I_U/(Z_m_U*M_i_U)	)^(1-r_c)*(	(1-dlt_UH)*M_i_U/M_i_UE	)^(1-r_m)*Z_m_H;
//%(52)
P_sm_UH	=	P_si_U*	(	dlt_i_U*I_U/(Z_m_U*M_i_U)	)^(1-r_c)*(	dlt_UH*M_i_U/M_i_UH	)^(1-r_m)*Z_m_H;
//%(53)
P_sm_EU	=	P_si_E*	(	dlt_i_E*I_E/(Z_m_E*M_i_E)	)^(1-r_c)*(	(1-dlt_EH)*M_i_E/M_i_EU	)^(1-r_m)*Z_m_H;
//%(54)
P_sm_EH	=	P_si_E*	(	dlt_i_E*I_E/(Z_m_E*M_i_E)	)^(1-r_c)*(	dlt_EH*M_i_E/M_i_EH	)^(1-r_m)*Z_m_H;

//%(55) Importing Goods
M_UH	=	P_sm_UH*(M_i_UH	+	M_c_UH);
//%(56)
M_UE	=	P_sm_UE*(M_i_UE	+	M_c_UE);
//%(57)
M_HU	=	P_sm_HU*(M_i_HU	+	M_c_HU);
//%(58)
M_HE	=	P_sm_HE*(M_i_HE	+	M_c_HE);
//%(59)
M_EU	=	P_sm_EU*(M_i_EU	+	M_c_EU);
//%(60)
M_EH	=	P_sm_EH*(M_i_EH	+	M_c_EH);

//%(61) Aggregate Import
M_H		=	M_HU	+	M_HE;
//%(62);
M_U		=	M_UE	+	M_UH;
//%(63)
M_E		=	M_EU	+	M_EH;

//%(64) Net Trade
NTs_H	=	(X_H	-	M_H)	+	P_so_H*O_x;
//%(65) Net Trade
NTs_U	=	(X_U	-	M_U )	-	P_so_U*O_U;
//%(66) Net Trade
NTs_E	=	(X_E	-	M_E)	-	P_so_E*O_E;

//%(67) Aggregate Export
X_H		=	(1/zetaE)*M_EH	+	(1/zetaU)*M_UH;
//%(68) Aggregate Export
X_U		=	(zetaU/zetaE)*M_EU	+	(zetaU)*M_HU;
//%(69) Aggregate Export
X_E		=	(zetaE)*M_HE	+	(zetaE/zetaU)*M_UE;


//%(74) Exchange rates
//%P_m_HU		=	e_HU*P_d_U;
//%(75)
//%P_m_HE		=	e_HE*P_d_E;
//%(76)
//%P_m_UE		=	e_UE*P_d_E;
//%(77)
//%P_m_UH		=	e_UH*P_d_H;
//%(78)
//%P_m_EU		=	e_EU*P_d_U;
//%(79)
//%P_m_EH		=	e_EH*P_d_H;
//%80-84
//%e_UH	=	1/e_HU;
//%e_UE	=	1/e_EU;
//%e_HE	=	1/e_EH;
//%e_UH	=	e_UE/e_HE;


//% Exchange rates
//%(74)
P_sm_HU     =   rer_HU*P_sc_H/P_sc_U;
//%(75)
P_sm_HE     =   rer_HE*P_sc_H/P_sc_E;
//%(76)
P_sm_UE     =   rer_UE*P_sc_U/P_sc_E;
//%(76b)
P_sm_UH     =   rer_UH*P_sc_U/P_sc_H;
//%(76c)
P_sm_EH     =   rer_EH*P_sc_E/P_sc_H;
//%(76d)
P_sm_EU     =   rer_EU*P_sc_E/P_sc_U;

//%(77)
rer_EH		=	1/rer_HE;
//%(78)
rer_UH		=	1/rer_HU;
//%(78a)
rer_EU		=	1/rer_UE;
//%(79)
rer_HU		=	rer_HE/rer_UE;

//%(85-86) Oil Price Parity 
P_so_H	=	rer_HU*P_so_U*P_sc_H/P_sc_U;
//%(87) 
P_so_H	=	rer_HE*P_so_E*P_sc_H/P_sc_E;

//%(88a)
phi_b_HU = exp(phi_b*B_s_HU);
//%(88b)
phi_b_HE = exp(phi_b*B_s_HE);
//%(88c)
phi_b_EH = exp(phi_b*B_s_EH);
//%(88d)
phi_b_EU = exp(phi_b*B_s_EU);
//%(88e)
phi_b_UE = exp(phi_b*B_s_UE);
//%(88f)
phi_b_UH = exp(phi_b*B_s_UH);

//%(89) UIP
beta_U*(q_c_U(+1)/(q_c_U))*(P_sc_U(+1)/P_sc_U)	=	beta_H*(	rer_HU(+1)/rer_HU	)*(	q_c_H(+1)/q_c_H	)*(P_sc_H(+1)/P_sc_H)*(	1	+	phi_b*B_s_HU	)^(-1)*phi_b_HU;
//%(88) 
beta_E*(q_c_E(+1)/(q_c_E))*(P_sc_E(+1)/P_sc_E)	=	beta_H*(	rer_HE(+1)/rer_HE	)*(	q_c_H(+1)/q_c_H	)*(P_sc_H(+1)/P_sc_H)*(	1	+	phi_b*B_s_HE	)^(-1)*phi_b_HE;

//%(90) Net Trade Balances
P_b_U*B_s_HU/phi_b_HU	-	B_s_HU(-1)	+	P_b_E*B_s_HE/phi_b_HE	-	B_s_HE(-1)		-	NTs_H	=	0;
//%(91)
P_b_H*B_s_UH/phi_b_UH	-	B_s_UH(-1)	+	P_b_E*B_s_UE/phi_b_UE	-	B_s_UE(-1)		-	NTs_U	=	0;
//%(92)
P_b_U*B_s_EU/phi_b_EU	-	B_s_EU(-1)	+	P_b_H*B_s_EH/phi_b_EH	-	B_s_EH(-1)		-	NTs_E	=	0;

//%(93) Market clearing for Bonds
(1/rer_HU)*B_s_HU/P_sc_H	=	-	zetaU*B_s_UH/P_sc_U;
//%(94) 
(1/rer_HE)*B_s_HE/P_sc_H	=	-	zetaE*B_s_EH/P_sc_E;
//%(95) 
(1/rer_UE)*B_s_UE/P_sc_U	=	-	(zetaE/zetaU)*B_s_EU/P_sc_E;

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%      Oil Industry;      %%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//%(71) Oil Market Clearing
Y_o		=	(1/zetaU)*O_U	+	(1/zetaE)*O_E		+	O_H;

//%(70) EXPORTED OIL
//O_x		=	(1/zetaU)*O_U	+	(1/zetaE)*O_E;

//%(72a) Oil market clearing (individual Countries)
O_U		=	O_y_U	+	O_c_U;
//%(72b)
O_E		=	O_y_E	+	O_c_E;

O_H		=	O_y_H	+	O_c_H;

//%%%%%%%%%%%%      Oil Exploiters;      %%%%%%%%%%%%%%
//%(96)
O = Z_op*F_u;

//%(97)
F_u = u_op*F(-1);

//%(98)
mc_o = r_f*(1/Z_op);

//%(99)
S1_o = Pstr_o*S2_o;
//%(99a)
O = (Pstr_o/P_so_H)^(-psi_o)*Y_o;
//%(100)
S1_o = O*psi_o*mc_o	+	rho_o*Lmbd_H*S1_o(+1);
//%(101)
S2_o = O*(psi_o - 1)	+	rho_o*Lmbd_H*omega_o*S2_o(+1);
//% (102)
P_so_H^(1-psi_o) = rho_o*(P_so_H(-1)*omega_o(-1)/pi_d_H)^(1-psi_o)	+	(1-rho_o)*Pstr_o^(1-psi_o);
//
omega_o = pi_o^gama_o*(STEADY_STATE(pi_d_H))^(1-gama_o);
//pi_o = (P_so_H/P_so_H(-1))*pi_d_H;


//%%%%%%%%%%%%      Field Explorers;      %%%%%%%%%%%%%%
//%(103)
NF = Z_nf*K_o;

//%(104)
r_f = (1 - beta_H)*r_k_H/beta_H*(1/u_op);

//%(105)
r_k_H = Z_nf*S_F;

//%(106)
S_F = Lmbd_H*(	r_f*u_op(+1)	-	P_sc_H*log(u_op(+1))	+ S_F(+1)	);

//%(107)
F = F(-1) + NF - O;

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%      Shocks       %%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

log(theta_o)		=	rho_zpo*log(theta_o(-1))		+	sig_po*eps_o;
psi_o		=	(1+theta_o)/theta_o;

log(Z_op)	=	rho_zop*log(Z_op(-1))	+	sig_zop*eps_zop;
log(Z_nf)	=	rho_znf*log(Z_nf(-1))		+	sig_znf*eps_znf;

end;

steady;

check;


shocks;
@#for co in countries
var eps_z_@{co}	= 1;
var eps_zo_@{co}	= 1;
var eps_zg_@{co}	= 1;
var eps_zi_@{co} 	= 1;
var eps_w_@{co} 	= 1;
@#endfor
var eps_o		=1;
var eps_zop 	=1; 
var eps_znf 	=1;
end;
stoch_simul(periods=1000);


write_latex_dynamic_model;
write_latex_static_model;


//% You may not need the Consumption and investment bundler functions.(44, 28, 29)
//Labour used by firms, is L_d, not just L.
//Small bug in 90-92, (exchange rate lag is not correct).
//Capital market, and resource constraint for home country.
//Must check the param values for other two countries
// Calculate the steady for model without rigidities
